"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signRequest = void 0;
const node_crypto_1 = require("node:crypto");
function signRequest(config, data) {
    config.headers ??= {};
    config.headers['X-MBX-APIKEY'] = data.key;
    config.params = { ...config.params, timestamp: Date.now() };
    config.params.signature = (0, node_crypto_1.createHmac)('sha256', data.secret)
        .update(new URLSearchParams({ ...config.params }).toString())
        .digest('hex');
    return config;
}
exports.signRequest = signRequest;
