"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signRequest = void 0;
const node_crypto_1 = require("node:crypto");
function signRequest(config, data) {
    const now = Math.trunc(Date.now() / 1000);
    config.headers ??= {};
    config.headers['CB-ACCESS-TIMESTAMP'] = now;
    config.headers['CB-ACCESS-KEY'] = data.key;
    config.headers['CB-ACCESS-SIGN'] = (0, node_crypto_1.createHmac)('sha256', data.secret)
        .update(`${now}${config.method.toUpperCase()}${config.url}${config.data
        ? JSON.stringify(config.data)
        : config.params && Object.keys(config.params).length
            ? `?${new URLSearchParams(config.params).toString()}`
            : ''}`)
        .digest('hex');
    return config;
}
exports.signRequest = signRequest;
