"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signRequest = void 0;
const node_crypto_1 = require("node:crypto");
function signRequest(config, data) {
    const now = Date.now();
    config.headers ??= {};
    config.headers['KC-API-TIMESTAMP'] = now.toString();
    config.headers['KC-API-KEY-VERSION'] = '2';
    config.headers['KC-API-KEY'] = data.key;
    config.headers['KC-API-PASSPHRASE'] = (0, node_crypto_1.createHmac)('sha256', data.secret)
        .update(data.passphrase)
        .digest('base64');
    config.headers['KC-API-SIGN'] = (0, node_crypto_1.createHmac)('sha256', data.secret)
        .update(`${now}${config.method.toUpperCase()}${config.url}${config.data
        ? JSON.stringify(config.data)
        : config.params && Object.keys(config.params).length
            ? `?${new URLSearchParams(config.params).toString()}`
            : ''}`)
        .digest('base64');
    return config;
}
exports.signRequest = signRequest;
